%define maj  2
%define min  0
%define rel  16

Summary:     A library which defends against buffer overflow and format string attacks
Name:        libsafe
Version:     %{maj}.%{min}.%{rel}
Release:     4.rh73.pp
License:     GPL
Group:       System Environment/Libraries
Source0:     http://www.research.avayalabs.com/project/%{name}/src/%{name}-%{maj}.%{min}-%{rel}.tgz
Source1:     %{name}.exclude
Patch0:      %{name}.patch
URL:         http://www.research.avayalabs.com/project/%{name}/
Buildroot:   /var/tmp/%{name}-root
Vendor:      Avaya Labs
Packager:    Peter Pramberger <peter.pramberger@member.fsf.org>
Provides:    %{name}.pp
Prereq:      fileutils glibc
BuildPrereq: fileutils glibc-devel gcc make
ExclusiveOS: linux


%description
%{name} is a library which defends against buffer overflow
and format string attacks. It works by putting a wrapper
around dangerous functions that contain any buffer overflows
within the current stack frame, so that the return address
can not be changed.


%prep
%setup -q -n %{name}-%{maj}.%{min}-%{rel}
%patch0 -p1
# Prepare docs
find doc -name Makefile -depth -exec rm -f {} \;


%build
FLAGS='-DDUMP_STACK -DLIBSAFE_DUMP_STACK_FILE=\"%{_tmppath}/%{name}_stack_dump\" -DDUMP_CORE -DNOTIFY_WITH_EMAIL'
export DEBUG_FLAGS="${RPM_OPT_FLAGS} ${FLAGS}"
make debug


# Do not strip, only compress documentation
%define __os_install_post /usr/lib/rpm/brp-compress


%install
rm -rf ${RPM_BUILD_ROOT}
mkdir -p ${RPM_BUILD_ROOT}%{_sysconfdir}
mkdir -p ${RPM_BUILD_ROOT}/%{_lib}
mkdir -p ${RPM_BUILD_ROOT}%{_mandir}/man8
make \
	LIBDIR=${RPM_BUILD_ROOT}/%{_lib}        \
	MANDIR=${RPM_BUILD_ROOT}%{_mandir}/man8 \
	install
ln -s %{name}.so.%{maj}.%{min}.%{rel} ${RPM_BUILD_ROOT}/%{_lib}/%{name}.so
ldconfig -n ${RPM_BUILD_ROOT}/%{_lib}
install -m 0644 %{SOURCE1} ${RPM_BUILD_ROOT}%{_sysconfdir}


%post
if [ $1 = 1 ]; then
  if ! grep "%{name}.so" %{_sysconfdir}/ld.so.preload >/dev/null 2>&1; then
    echo "/%{_lib}/%{name}.so" >> %{_sysconfdir}/ld.so.preload
  fi
  cat << _EOF_

** LibSafe Info ** LibSafe Info ** LibSafe Info ** LibSafe Info **

%{name} will now be preloaded (%{_sysconfdir}/ld.so.preload) on every system
call. So be careful when manipulating this file as login will be
impossible when the library is not found. At this point only boo-
ting with a rescue disk and manually editing this file will help.

If you wish to exclude some programs from use with %{name}, put the
filenames using the absolute pathname in %{_sysconfdir}/%{name}.exclude. Note
that this absolute pathname must not contain any symbolic links.

** LibSafe Info ** LibSafe Info ** LibSafe Info ** LibSafe Info **

_EOF_
fi
ldconfig


%preun
if [ $1 = 0 ]; then
  if [ -f %{_sysconfdir}/ld.so.preload ]; then
    grep -v "%{name}.so" %{_sysconfdir}/ld.so.preload > tmpfile
    cat tmpfile > %{_sysconfdir}/ld.so.preload; rm -f tmpfile
    if [ ! -s %{_sysconfdir}/ld.so.preload ]; then
      rm -f %{_sysconfdir}/ld.so.preload
    fi
  fi
fi


%postun
ldconfig


%clean
rm -rf ${RPM_BUILD_ROOT}


%files
%defattr(-,root,root)
%doc COPYING ChangeLog EMAIL_NOTIFICATION INSTALL README
%doc %dir doc
%config(noreplace) %attr(644,root,root) %{_sysconfdir}/%{name}.exclude
/%{_lib}/*
%{_mandir}/man8/*


%changelog
* Mon Dec 12 2005 peter.pramberger@member.fsf.org
- some spec file cleanups

* Fri Jul 29 2005 peter.pramberger@member.fsf.org
- created

